% propositions A,B ::= and(A,B) | imp(A,B)
% checkable terms M,N ::= pair(M,N) | fun(X,M) | R
% synth terms R ::= fst(R) | snd(R) | app(R,M) | X
% context O ::= tp(X,A).O | nil

% check(+O, +M, +A) type checking
% synth(+O, +R, -A) type synthesis
% check(+O, +M, -A) type inference

eq(A, B) :- unify_with_occurs_check(A,B).

check(O, pair(M,N), and(A,B)) :-
    check(O, M, A),
    check(O, N, B).

check(O, fun(X,M), imp(A,B)) :-
    check([tp(X,A) | O], M, B).

check(O, R, A) :- synth(O, R, B), eq(A,B).

synth(O, fst(R), A) :- synth(O, R, and(A,B)).
synth(O, snd(R), B) :- synth(O, R, and(A,B)).
synth(O, app(R,M), B) :-
    synth(O, R, imp(A,B)),
    check(O, M, A2),
    eq(A,A2).

synth([tp(X,A2) | O], X, A) :- eq(A,A2).
synth([tp(Y,B) | O], X, A) :- Y\=X, synth(O, X, A).
















%?- check([], fun(x,x), imp(a,a)).
%?- check([], fun(x,fun(y,x)), imp(a,imp(b,a))).
%?- check([], fun(x,fun(y,y)), imp(a,imp(b,b))).
%?- check([], fun(x,fun(y,y)), imp(a,imp(b,a))).

%?- check([], fun(x,fun(x,x)), imp(a,imp(b,b))).
%?- check([], fun(x,fun(x,x)), imp(a,imp(b,a))).
%?- trace.

% edit

% uncurrying
%?- check([], fun(f,fun(p,app(app(f,fst(p)),snd(p)))), imp(imp(a,imp(b,c)),imp(and(a,b),c))).
% currying
%?- check([], fun(f,fun(x,fun(y,app(f,pair(x,y))))),   imp(imp(and(a,b),c),imp(a,imp(b,c)))).

% check(+O,+M,-A) by unification
%?- check([], fun(x,x), A).
%?- check([], fun(f,fun(x,fun(y,app(f,pair(x,y))))), A).

%?- check([], fun(x, app(x,x)), A).

% check(+O, -M, +A)
%?- check([], M, imp(a,a)).
